<!--
  ~ iparapheur Web
  ~ Copyright (C) 2019-2025 Libriciel SCOP
  ~
  ~ This program is free software: you can redistribute it and/or modify
  ~ it under the terms of the GNU Affero General Public License as published by
  ~ the Free Software Foundation, either version 3 of the License, or
  ~ (at your option) any later version.
  ~
  ~ This program is distributed in the hope that it will be useful,
  ~ but WITHOUT ANY WARRANTY; without even the implied warranty of
  ~ MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  ~ GNU Affero General Public License for more details.
  ~
  ~ You should have received a copy of the GNU Affero General Public License
  ~ along with this program. If not, see <http://www.gnu.org/licenses/>.
  -->

<!-- Header -->

<div class="mt-3">
  <app-desk-search-input
    class="w-50 d-block"
    [(desks)]="_selectedDeskList"
    [multiple]="false"
    [clearable]="false"
    (desksChange)="selectedSourceDeskChanged()"
    [genericValidatorsAvailable]="false"
    [retrieveDeskFunction]="retrieveDesksFn"
    #deskSelector>
  </app-desk-search-input>

  <div *ngIf="!selectedDesk" class="pt-3">
    <span
      class="text-info"
      [innerText]="messages.SELECT_DESK_INFO_TEXT">
    </span>
  </div>
</div>

<hr class="my-2">

<div class="my-2 d-flex flex-row">

  <button
    ls-button
    [icon]="commonIcons.CREATE_ICON"
    [text]="messages.CREATE_ABSENCE_BUTTON_TITLE"
    [disabled]="!selectedDesk"
    (click)="openCreationModal()">
  </button>

</div>

<!-- The `aria-labelledby` does not have a label available, we go for the simple label -->
<!-- eslint-disable-next-line -->
<table
  [summary]="messages.DELEGATIONS_LIST"
  class="bg-white mt-2 table table-striped table-fixed table-borderless border shadow-sm table-text-overflow">

  <thead class="border">
    <tr>
      <th
        scope="col"
        class="th-sm col-date-fixed-size"
        (click)="onRowOrderClicked(sortByEnum.Start)">
        <fa-icon
          class="{{ sortBy === sortByEnum.Start ? 'visible' : 'invisible' }}"
          [icon]="asc ? caretUp : caretDown"
          [fixedWidth]="true">
        </fa-icon>
        {{ messages.BEGINNING }}
      </th>
      <th
        scope="col"
        class="th-sm col-date-fixed-size"
        (click)="onRowOrderClicked(sortByEnum.End)">
        <fa-icon
          class="{{ sortBy === sortByEnum.End ? 'visible' : 'invisible' }}"
          [icon]="asc ? caretUp : caretDown"
          [fixedWidth]="true">
        </fa-icon>
        {{ messages.END }}
      </th>
      <th
        scope="col"
        class="th-sm col-6"
        (click)="onRowOrderClicked(sortByEnum.SubstituteDesk)">
        <fa-icon
          class="{{ sortBy === sortByEnum.SubstituteDesk ? 'visible' : 'invisible' }}"
          [icon]="asc ? caretUp : caretDown"
          [fixedWidth]="true">
        </fa-icon>
        {{ messages.REPLACEMENT_DESK }}
      </th>
      <th
        scope="col"
        class="th-sm col-6"
        (click)="onRowOrderClicked(sortByEnum.Typology)">
        <fa-icon
          class="{{ sortBy === sortByEnum.Typology ? 'visible' : 'invisible' }}"
          [icon]="asc ? caretUp : caretDown"
          [fixedWidth]="true">
        </fa-icon>
        {{ messages.TYPOLOGY }}
      </th>
      <th
        scope="col"
        class="th-sm col-buttons-fixed-size"
        [innerText]="commonMessages.ACTIONS">
      </th>
    </tr>
  </thead>
  <tbody *ngIf="selectedDesk">
    <tr *ngFor="let absence of absenceList">
      <td><span class="sortable-row">{{ absence?.start | date: 'shortDate' }}</span></td>
      <td><span class="sortable-row">{{ absence?.end | date: 'shortDate' }}</span></td>
      <td><span class="sortable-row">{{ absence?.substituteDesk?.name | namePipe }}</span></td>
      <td><span class="sortable-row">{{ absence?.type?.name || ' *' }} / {{ absence?.subtype?.name || '* ' }}</span></td>
      <td>
        <button
          ls-button
          class="btn-outline btn-outline-danger red btn-sm"
          [icon]="commonIcons.DELETE_ICON"
          [weight]="LsButtonWeight.SECONDARY"
          [style]="LsButtonStyle.DANGER"
          [ngbTooltip]="commonMessages.DELETE"
          (click)="deleteDelegation(absence)">
        </button>
      </td>
    </tr>
  </tbody>
  <tbody
    app-list-loader
    [data]="absenceList"
    [loading]="loading"
    [colspan]="colspan"
    [emptyMessage]="commonMessages.EMPTY_ABSENCE_LIST">
  </tbody>
</table>
